<script setup>
    import { ref } from 'vue';
    import { useForm } from '@inertiajs/inertia-vue3';
    import JetActionMessage from '@/Jetstream/ActionMessage.vue';
    import JetButton from '@/Jetstream/Button.vue';
    import JetFormSection from '@/Jetstream/FormSection.vue';
    import JetInput from '@/Jetstream/Input.vue';
    import JetInputError from '@/Jetstream/InputError.vue';
    import JetLabel from '@/Jetstream/Label.vue';
    import vSelect from 'vue-select'
    import JetTextarea from '@/Jetstream/Textarea.vue';
    import 'vue-select/dist/vue-select.css';
    import 'v-calendar/dist/style.css';
    import {Calendar, DatePicker} from 'v-calendar';
    const props = defineProps({
        jobListing: {
            type:Object,
            default:{}
        },
    });


    const form = useForm({
        id:!_.isEmpty(props.jobListing) ? props.jobListing.id : null,
        title: !_.isEmpty(props.jobListing) ? props.jobListing.title : '',
        short_description: !_.isEmpty(props.jobListing) ? props.jobListing.short_description : '',
        description:!_.isEmpty(props.jobListing) ?  props.jobListing.short_description : '',
        start_date:!_.isEmpty(props.jobListing) ? props.jobListing.start_date : '',
        end_date:!_.isEmpty(props.jobListing) ? props.jobListing.end_date : '',
        job_area_id:!_.isEmpty(props.jobListing) ? props.jobListing.job_area_id : null,
    });

    const storeJobListing = () => {
        form.post(route('job.listing.store'), {
            errorBag: 'storeJobListing',
            preserveScroll: true,
            onSuccess: () => form.reset(),
            onError: () => {

            },
        });
    };
</script>

<template>
    <JetFormSection @submitted="storeJobListing" :fullForm="true">
        <template #form>
            <div class="col-span-6 sm:col-span-4">
                <JetLabel for="title" value="Title" />
                <JetInput
                        id="title"
                        ref="titleInput"
                        v-model="form.title"
                        type="text"
                        class="mt-1 block w-full"
                        autocomplete="title"
                />
                <JetInputError :message="form.errors.title" class="mt-2" />
            </div>


            <div class="col-span-6 sm:col-span-4">
                <JetLabel for="job_area_id" value="Job Area" />

                <vSelect
                        id="job_area_id"
                        v-model="form.job_area_id"
                        :value="form.job_area_id"
                        class="mt-1 block w-full"
                        autocomplete="job_area_id"
                        placeholder="Select Job Area"
                        :options="options"
                        :reduce="(option) => option.id"
                        label="name"
                />
                <JetInputError :message="form.errors.job_area_id" class="mt-2" />
            </div>

            <div class="col-span-6 sm:col-span-4">
                <JetLabel for="short_description" value="Short Description" />
                <JetTextarea
                        id="short_description"
                        ref="shortDescriptionInput"
                        v-model="form.short_description"
                        type="text"
                        class="mt-1 block w-full"
                />
                <JetInputError :message="form.errors.short_description" class="mt-2" />
            </div>



            <div class="col-span-6 sm:col-span-4">
                <JetLabel for="description" value="Description" />
                <JetTextarea
                        id="description"
                        ref="descriptionInput"
                        v-model="form.description"
                        type="text"
                        class="mt-1 block w-full"
                />
                <JetInputError :message="form.errors.description" class="mt-2" />
            </div>

            <div class="col-span-6 sm:col-span-4">
                <JetLabel for="start_date" value="Start Date" />


                <DatePicker    class="mt-1 block w-full" v-model="form.start_date" mode="date"  is-required>
                    <template v-slot="{ inputValue, inputEvents }">
                        <div class="flex justify-center items-center">
                            <input
                                    :value="inputValue"
                                    v-on="inputEvents"
                                    class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
                            />
                        </div>
                    </template>
                </DatePicker>
                <JetInputError :message="form.errors.start_date" class="mt-2" />
            </div>

            <div class="col-span-6 sm:col-span-4">
                <JetLabel for="end_date" value="End Date" />


                <DatePicker    class="mt-1 block w-full" v-model="form.end_date" mode="date"  is-required>
                    <template v-slot="{ inputValue, inputEvents }">
                        <div class="flex justify-center items-center">
                            <input
                                    :value="inputValue"
                                    v-on="inputEvents"
                                    class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
                            />
                        </div>
                    </template>
                </DatePicker>
                <JetInputError :message="form.errors.end_date" class="mt-2" />
            </div>

        </template>

        <template #actions>
            <JetActionMessage :on="form.recentlySuccessful" class="mr-3">
                Saved.
            </JetActionMessage>

            <JetButton :class="{ 'opacity-25': form.processing }" :disabled="form.processing">
                Save
            </JetButton>
        </template>
    </JetFormSection>
</template>
<script>
    export default {

        data() {
            return {
                options: [],
            }

        },
        methods:{
            fetchAreas()
            {

                let here = this;
                axios.get(route('job.areas.index')).then(response => {
                    here.options = response.data;
                });


            }
        },
        mounted(){
            this.fetchAreas();
        }
    }
</script>